import sys, time, pgmrender, gobject
from pgm import render, log
from pgm.layout import window, group
from pgm.form import rectangle, stroke, color, image, label
from pgm.timing import controller, modifier, keyframe

render.init('opengl1')
log.set_level(log.DEBUG)

global ctrl, rect1, rect2, rect3, grp, win

def end_cb(toto):
    print 'End animation callback.'

def key_press_cb(event):
    global rect1, rect2, rect3, grp, win, ctrl
#     if event.keyval == pgmrender.KEY_w:
#         grp.reorder_child(rect1, 0)
#     if event.keyval == pgmrender.KEY_x:
#         grp.reorder_child(rect1, 1)
#     if event.keyval == pgmrender.KEY_c:
#         grp.reorder_child(rect1, 2)
    if event.keyval == pgmrender.KEY_ESCAPE:
        win.main_quit()
    elif event.keyval == pgmrender.KEY_s:
        ctrl.start()
    elif event.keyval == pgmrender.KEY_q:
        ctrl.stop()

def main(args):
    global rect1, rect2, rect3, grp, win, ctrl

    win = window.Window(title='Layout', size=(800,600))
    grp = group.Group()

#     rect1 = rectangle.Rectangle((200,150), (100,100),
#                                 paint=color.Color((255,0,0,255)))
#     rect2 = rectangle.Rectangle((200,150), (150,150),
#                                 paint=color.Color((0,255,0,255)))
    rect3 = rectangle.RoundRectangle((200,150), (300,225),
                                     paint=color.Color((255,100,55,255)),
                                     arc=(25,25),
                                     stroke=stroke.Stroke(width=3.0))
    lbl = label.Label()
    lbl.text = "Pigment label"

    #rect1.tz = -10
    rect3.tx = -50

#     grp.add(rect1)
#     grp.add(rect2)
    grp.add(rect3)
    win.add(lbl)
    win.add(grp)

    timeline = [keyframe.KeyFrame(-50.0, 0.0),
                keyframe.KeyFrame(50.0, 1.0)]
    modif = modifier.Modifier([rect3], 'tx', timeline)
    timeline2 = [keyframe.KeyFrame(255.0, 0.0),
                 keyframe.KeyFrame(0.0, 0.5),
                 keyframe.KeyFrame(255.0, 1.0)]
    modif2 = modifier.Modifier([rect3], 'opacity', timeline2)
    ctrl = controller.Controller(begin=0, duration=500, resolution=2,
                                 repeat_behavior=controller.REVERSE,
                                 repeat_count=4, end_behavior=controller.BEGIN,
                                 modifiers=[modif,modif2],
                                 interpolation=controller.SINUSOIDAL,
                                 end_callback=end_cb)

    # Signal connections
    win.sig_exit_event.connect(lambda _: win.main_quit())
    win.sig_key_press_event.connect(key_press_cb)

    # Start the loop
    gobject.timeout_add(25, win.update)
    win.main()

if __name__ == '__main__':
    sys.exit(main(sys.argv[1:]))
